define(["exports","./dom.js","./layoutmanager.js"],function(_exports,_dom,_layoutmanager){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;var scopes=[];function getElementToAutoFocus(view,options){return options&&!1===options.findAutoFocusElement||!(options=view.querySelector(".autofocus"))?function(parent,limit,excludeClass){for(var elems=(parent||getDefaultScope()).querySelectorAll(function(excludeClass){if(!excludeClass)return focusableQuery;for(var newQuerySelectors=[focusableQuerySelectors.length],i=0,length=focusableQuerySelectors.length;i<length;i++)newQuerySelectors[i]=focusableQuerySelectors[i]+":not(."+excludeClass+")";return newQuerySelectors.join(",")}(excludeClass)),focusableElements=[],i=0,length=elems.length;i<length;i++){var elem=elems[i];if(isCurrentlyFocusableInternal(elem)&&(focusableElements.push(elem),limit&&focusableElements.length>=limit))break}return focusableElements}(view,1,"noautofocus")[0]:options}function autoFocus(view,options){view=getElementToAutoFocus(view,options);return view&&focus(view,options),view}function focus(element,options){for(;element.classList.contains("focusable");){var autoFocusElement=getElementToAutoFocus(element,options);if(!autoFocusElement)break;element=autoFocusElement}focusInternal(element,options)}function focusInternal(element,options){try{var preventScroll=options?options.preventScroll:null;null==preventScroll&&_layoutmanager.default.tv&&(preventScroll=!0),element.focus({preventScroll:preventScroll})}catch(err){console.log("Error in focusManager.autoFocus: "+err)}}var focusableTagNames=["INPUT","TEXTAREA","SELECT","BUTTON","A"],focusableQuerySelectors=focusableTagNames.map(function(t){return t+':not([tabindex="-1"]):not(:disabled)'}),focusableQuery=(focusableQuerySelectors.push(".focusable"),focusableQuerySelectors.join(","));var focusableParentQuery=focusableTagNames.join(",")+",.focusable";function focusableParent(elem){return elem.closest(focusableParentQuery)||elem}function isCurrentlyFocusableInternal(elem){return null!==elem.offsetParent}function getDefaultScope(){return scopes[0]||document.body}var focusContainerQueries=[".focuscontainer,.focuscontainer-x,.focuscontainer-left",".focuscontainer,.focuscontainer-x,.focuscontainer-right",".focuscontainer,.focuscontainer-y",".focuscontainer,.focuscontainer-y,.focuscontainer-down"];function getNearestElement(activeElement,activeElementRect,direction,focusableElements,focusableContainer){for(var nearestElement,point1x=parseFloat(activeElementRect.left)||0,point1y=parseFloat(activeElementRect.top)||0,point2x=parseFloat(point1x+activeElementRect.width-1)||point1x,point2y=parseFloat(point1y+activeElementRect.height-1)||point1y,minDistance=1/0,i=0,length=focusableElements.length;i<length;i++){var curr=focusableElements[i];if(curr!==activeElement&&curr!==focusableContainer){var elementRect=curr.getBoundingClientRect(),elementRectWidth=elementRect.width,elementRectHeight=elementRect.height,elementRectLeft=elementRect.left,elementRectTop=elementRect.top;if(elementRectWidth||elementRectHeight){switch(direction){case 0:if(elementRectLeft>=activeElementRect.left)continue;if(elementRect.right===activeElementRect.right)continue;break;case 1:if(elementRect.right<=activeElementRect.right)continue;if(elementRectLeft===activeElementRect.left)continue;break;case 2:if(elementRectTop>=activeElementRect.top)continue;if(elementRect.bottom>=activeElementRect.bottom)continue;break;case 3:if(elementRect.bottom<=activeElementRect.bottom)continue;if(elementRectTop<=activeElementRect.top)continue}var x2=elementRectLeft+elementRectWidth-1,y2=elementRectTop+elementRectHeight-1,distX=void 0,distY=void 0;switch(direction){case 0:var intersectY=intersects(point1y,point2y,elementRectTop,y2),distX=Math.abs(point1x-Math.min(point1x,x2)),distY=intersectY?0:1+Math.min(Math.abs(point1y-y2),Math.abs(point2y-elementRectTop));break;case 1:intersectY=intersects(point1y,point2y,elementRectTop,y2);distX=Math.abs(point2x-Math.max(point2x,elementRectLeft)),distY=intersectY?0:1+Math.min(Math.abs(point1y-y2),Math.abs(point2y-elementRectTop));break;case 2:var intersectX=intersects(point1x,point2x,elementRectLeft,x2);distY=Math.abs(point1y-Math.min(point1y,y2)),distX=intersectX?0:1+Math.min(Math.abs(point1x-x2),Math.abs(point2x-elementRectLeft));break;case 3:intersectX=intersects(point1x,point2x,elementRectLeft,x2);distY=Math.abs(point2y-Math.max(point2y,elementRectTop)),distX=intersectX?0:1+Math.min(Math.abs(point1x-x2),Math.abs(point2x-elementRectLeft))}elementRectWidth=Math.sqrt(distX*distX+distY*distY);elementRectWidth<minDistance&&(nearestElement=curr,minDistance=elementRectWidth)}}}return nearestElement}function nav(activeElement,direction){var container=(activeElement=(activeElement=activeElement||document.activeElement)&&focusableParent(activeElement))?function(elem,direction){return direction=focusContainerQueries[direction],elem.closest(direction)||document.body}(activeElement,direction):getDefaultScope();if(activeElement){var selectedIndex,activeElementRect,focusableContainer=activeElement.closest(".focusable");if(selectedIndex=container.classList.contains("focus-by-sequence")?(focusable=container.querySelectorAll(focusableQuery),selectedIndex=Array.prototype.indexOf.call(focusable,activeElement),selectedIndex=0===direction||2===direction?selectedIndex-1:selectedIndex+1,focusable[selectedIndex=Math.min(Math.max(0,selectedIndex),focusable.length-1)]):(focusable=container.querySelectorAll(focusableQuery),activeElementRect=activeElement.getBoundingClientRect(),getNearestElement(activeElement,activeElementRect,direction,focusable,focusableContainer))){!activeElement||(focusable=selectedIndex.closest(".focusable"))&&focusable!==selectedIndex&&focusableContainer!==focusable&&(selectedIndex=focusable);var focusable=selectedIndex.getAttribute("data-focusabletype");if("autofocus"!==focusable)return"nearest"===focusable?(activeElementRect=activeElementRect||activeElement.getBoundingClientRect(),void((focusable=getNearestElement(activeElement,activeElementRect,direction,selectedIndex.querySelectorAll(focusableQuery),focusableContainer))?focusInternal(focusable):autoFocus(selectedIndex))):void focusInternal(selectedIndex,{});autoFocus(selectedIndex)}}else autoFocus(container,{findAutoFocusElement:!1})}function intersectsInternal(a1,a2,b1,b2){return a1<=b1&&b1<=a2||a1<=b2&&b2<=a2}function intersects(a1,a2,b1,b2){return intersectsInternal(a1,a2,b1,b2)||intersectsInternal(b1,b2,a1,a2)}_exports.default={autoFocus:autoFocus,focus:focus,focusableParent:focusableParent,moveLeft:function(sourceElement){nav(sourceElement,0)},moveRight:function(sourceElement){nav(sourceElement,1)},moveUp:function(sourceElement){nav(sourceElement,2)},moveDown:function(sourceElement){nav(sourceElement,3)},sendText:function(text){document.activeElement.value=text},isCurrentlyFocusable:function(elem){return!!elem.matches(focusableQuery)&&null!==elem.offsetParent},pushScope:function(elem){scopes.push(elem)},popScope:function(elem){scopes.length&&--scopes.length},hasExclusiveFocusScope:function(){return scopes.length},getCurrentScope:getDefaultScope}});